package vaja05.igra;

import java.util.Random;

public class Logika {
    static int[][] polja;
    static int tocke;
    static boolean konec;

    public static void zacniNovoIgro(int velikost) {
        polja = new int[velikost][velikost];
        tocke = 0;
        konec = false;

        dodajPloscico();
    }

    public static void koncajIgro() {
        if (konec) {
            System.exit(0);
        }
        konec = true;
    }

    public static int vrniPloscico(int i, int j) {
        return polja[i][j];
    }

    public static int vrniTocke() {
        return tocke;
    }

    public static boolean jeZmagal() {
        return false;
    }

    public static boolean jeKonec() {
        return konec;
    }

    public static void naslednjaPoteza(int smer) {
        switch (smer) {
            case 0:
                premikVLevo2();
        }

        dodajPloscico();
    }

    static void premikVLevo2() {
        for (int[] vrstica : polja) {
            int dest = 0;
            for (int curr = 1; curr < vrstica.length; curr++) {
                if (vrstica[dest] == 0) {
                    vrstica[dest] = vrstica[curr];
                } else if (vrstica[dest] == vrstica[curr]) {
                    vrstica[dest] *= 2;
                    dest++;
                } else {
                    vrstica[dest + 1] = vrstica[curr];
                    dest++;
                }
                vrstica[curr] = 0;
            }
        }
    }

    static void premikVLevo() {
        for (int[] vrstica : polja) {
            int prej = -1;
            for (int i = 0; i < vrstica.length; i++) {
                if (vrstica[i] == 0) continue;
                if (prej != -1 && vrstica[i] == vrstica[prej]) {
                    vrstica[prej] *= 2;
                    vrstica[i] = 0;
                } else {
                    prej = i;
                }
            }

            prej = 0;
            for (int i = 0; i < vrstica.length; i++) {
                if (prej == -1 && vrstica[i] == 0) {
                    prej = i;
                    continue;
                }
                if (prej != -1) {
                    vrstica[prej] = vrstica[i];
                    vrstica[i] = 0;
                    prej = -1;
                }
            }
        }
    }

    static void dodajPloscico() {
        Random random = new Random();

        boolean prosto = false;
        for (int[] vrstica : polja) {
            for (int polje : vrstica) {
                if (polje == 0) {
                    prosto = true;
                    break;
                }
            }
        }

        if (!prosto) {
            return;
        }

        int x, y;
        do {
            y = random.nextInt(polja.length);
            x = random.nextInt(polja[0].length);
        } while (polja[y][x] != 0);

        if (random.nextInt(10) == 9) {
            polja[y][x] = 4;
        } else {
            polja[y][x] = 2;
        }
    }
}
